<template>
  <!-- 所在路段选择弹层 -->
  <SuperTableSelectorDialog
    width="75%"
    v-on="$listeners"
    v-bind="$attrs"
    title="事件选择"
    selectKey="eventId"
    selectLabel="roadName"
    select-title-name="所在路段"
    :treeTabList="['行政维度']"
    :isShow.sync="isShowDialog"
    hintLanguage="提示：请在列表中选择事件后，点击确认。"
    :search-option="optionList"
    :treeData="orgData"
    :tree-item="treeItem"
    :defaultTreeExpandLevel="4"
    :table-data="tableData"
    :table-options="tableOptions"
    :table-loading="tableLoading"
    :tableParams="params"
    isSingleChoice
    :isShowSelect="false"
    @open="open"
    @closed="closed"
    @tableRefresh="getTableData"
    @treeChange="treeChange"
    ref="superTableSelectorDialog"
  />
</template>

<script>
import {orgTree} from '@/api/systemInterface'
import {tableData} from '@/api/patrolAndRescue/commandDispatch/eventInquiry'
import {refineRequestBody, setQueryValue} from '@/utils/requestWrappers'
import SuperTableSelectorDialog from '@/components/SuperTableSelectorDialog/index.vue'
import { getDictionaryByCode,dictionaryEscape  } from '@/utils/dictionary'

export default {
  name: 'EventChoiceDialog',
  components: {SuperTableSelectorDialog},
  props: {
    isShow: {
      default: false,
      type: Boolean
    }
  },
  data() {
    return {
      orgData: [], // 组织树
      optionList: [
        { title: '事件类型', prop: ['event_Type_'], type: 'select', option: getDictionaryByCode('sjlx'), multiple: false },
        { title: '事件来源', prop: ['event_Src_'], type: 'select', option: getDictionaryByCode('sjly'), multiple: false },
        { title: '所属路段', prop: ['road_Name_'], type: 'input', default: true },
      ],
      tableOptions: [
        {label: '报案电话', minWidth: '30', prop: 'eventTel'},
        {label: '事件类型', minWidth: '40', prop: 'eventType', formatter: ({eventType}) => dictionaryEscape('sjlx', eventType) || '-'},
        {label: '事件来源', minWidth: '45', prop: 'eventSrc', formatter: ({eventSrc}) => dictionaryEscape('sjly', eventSrc) || '-'},
        {label: '事件等级', minWidth: '40', prop: 'eventLevel', formatter: ({eventLevel}) => eventLevel ? eventLevel+'级' : '-'},
        {label: '所属路段', minWidth: '50', prop: 'roadName' },
        {label: '事件编号', minWidth: '50', prop: 'eventNo'}
      ],
      params: {
        pageBean: { pageSize: 20, page: 1, total: 0 },
        querys: [
          { operation: 'EQUAL', property: 'event_Type_', value: '' },
          { operation: 'EQUAL', property: 'event_Src_', value: '' },
          { operation: 'LIKE', property: 'road_Name_', value: '' }
        ],
        sorter: []
      },
      tableData: [], // 所在路段数据
      treeItem: {}, // 树选中
      tableLoading: false // 表格loading
    }
  },
  computed: {
    isShowDialog: {
      get() {
        return this.isShow
      },
      set(val) {
        this.$emit('update:isShow', val)
      }
    }
  },
  created() {
    this.getOrgTreeData()
  },
  methods: {
    // 打开弹层时触发
    open() {
      this.getTableData()
    },

    // 关闭弹层触发
    closed() {
      const {orgData} = this
      // 重置data中的数据
      Object.assign(this.$data, this.$options.data.call(this), {orgData})
      this.treeItem = this.orgData[0] || {}
      setQueryValue(this.params, 'COMPANY_IDS_', this.treeItem?.path || '')
    },

    // 获取公司树
    async getOrgTreeData() {
      this.orgData = await orgTree()
      this.treeItem = this.orgData[0] || {}
      setQueryValue(this.params, 'COMPANY_IDS_', this.treeItem?.path || '')
    },

    //获取所在路段列表数据
    async getTableData() {
      this.tableData = []
      this.tableLoading = true
      const {total = 0, rows = []} = await tableData(refineRequestBody(this.params))
      this.params.pageBean.total = total
      this.tableData = rows.map(i => {
        const { id:eventId, eventNo, eventType, eventSrc, roadName, eventTel } = i
        return { eventId, eventNo, eventType, eventSrc, eventTel, roadName }
      })
      this.tableLoading = false
    },

    // 树改变
    treeChange(treeItem) {
      // 修改对应的字段值
      setQueryValue(this.params, 'COMPANY_IDS_', treeItem?.path || '')
      this.getTableData()
    }
  }
}
</script>

<style lang="scss" scoped>

</style>
